--- stacktrace.1479256809.txt	2016-11-15 23:07:56.000000000 -0800
+++ stacktrace.1479256822.txt	2016-11-15 23:07:56.000000000 -0800
@@ -330,7 +330,7 @@
 No locals.
 #1  0x00007f62620d00e9 in DS_Sleep (ticks=ticks@entry=100) at ldap/servers/slapd/util.c:1035
         mSecs = <optimized out>
-        tm = {tv_sec = 0, tv_usec = 87821}
+        tm = {tv_sec = 0, tv_usec = 9519}
 #2  0x00007f6257595907 in deadlock_threadmain (param=<optimized out>) at ldap/servers/slapd/back-ldbm/dblayer.c:4466
         rval = <optimized out>
         priv = 0x7f6262d16740
@@ -359,9 +359,9 @@
 No locals.
 #1  0x00007f62620d00e9 in DS_Sleep (ticks=ticks@entry=250) at ldap/servers/slapd/util.c:1035
         mSecs = <optimized out>
-        tm = {tv_sec = 0, tv_usec = 78314}
+        tm = {tv_sec = 0, tv_usec = 41801}
 #2  0x00007f6257599a26 in checkpoint_threadmain (param=<optimized out>) at ldap/servers/slapd/back-ldbm/dblayer.c:4675
-        time_of_last_checkpoint_completion = 1479256758
+        time_of_last_checkpoint_completion = 1479256819
         interval = <optimized out>
         rval = <optimized out>
         priv = <optimized out>
@@ -398,7 +398,7 @@
 No locals.
 #1  0x00007f62620d00e9 in DS_Sleep (ticks=ticks@entry=250) at ldap/servers/slapd/util.c:1035
         mSecs = <optimized out>
-        tm = {tv_sec = 0, tv_usec = 137152}
+        tm = {tv_sec = 0, tv_usec = 121314}
 #2  0x00007f6257595b7f in trickle_threadmain (param=<optimized out>) at ldap/servers/slapd/back-ldbm/dblayer.c:4892
         interval = 250
         rval = <optimized out>
@@ -428,7 +428,7 @@
 No locals.
 #1  0x00007f62620d00e9 in DS_Sleep (ticks=<optimized out>) at ldap/servers/slapd/util.c:1035
         mSecs = <optimized out>
-        tm = {tv_sec = 0, tv_usec = 323317}
+        tm = {tv_sec = 0, tv_usec = 33264}
 #2  0x00007f62575e8784 in perfctrs_wait (milliseconds=milliseconds@entry=1000, priv=<optimized out>, db_env=<optimized out>) at ldap/servers/slapd/back-ldbm/perfctrs.c:100
         interval = <optimized out>
 #3  0x00007f6257590707 in perf_threadmain (param=<optimized out>) at ldap/servers/slapd/back-ldbm/dblayer.c:3966
@@ -601,8 +601,8 @@
 No locals.
 #1  0x00007f6260278c87 in pt_TimedWait (cv=cv@entry=0x7f6262fadfa8, ml=0x7f6262e01340, timeout=timeout@entry=30000) at ../../../nspr/pr/src/pthreads/ptsynch.c:264
         rv = <optimized out>
-        now = {tv_sec = 1479256791, tv_usec = 66145}
-        tmo = {tv_sec = 1479256821, tv_nsec = 66145000}
+        now = {tv_sec = 1479256821, tv_usec = 773957}
+        tmo = {tv_sec = 1479256851, tv_nsec = 773957000}
         ticks = <optimized out>
 #2  0x00007f626027916e in PR_WaitCondVar (cvar=0x7f6262fadfa0, timeout=timeout@entry=30000) at ../../../nspr/pr/src/pthreads/ptsynch.c:398
         rv = <optimized out>
@@ -630,12 +630,12 @@
 Thread 33 (Thread 0x7f623affd700 (LWP 28293)):
 #0  pthread_cond_timedwait@@GLIBC_2.3.2 () at ../nptl/sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S:238
 No locals.
-#1  0x00007f6260278c87 in pt_TimedWait (cv=cv@entry=0x7f6262df6018, ml=0x7f6262df6060, timeout=timeout@entry=10000) at ../../../nspr/pr/src/pthreads/ptsynch.c:264
+#1  0x00007f6260278c87 in pt_TimedWait (cv=cv@entry=0x7f6262df6018, ml=0x7f6262df6060, timeout=timeout@entry=6000) at ../../../nspr/pr/src/pthreads/ptsynch.c:264
         rv = <optimized out>
-        now = {tv_sec = 1479256803, tv_usec = 310388}
-        tmo = {tv_sec = 1479256813, tv_nsec = 310388000}
+        now = {tv_sec = 1479256818, tv_usec = 310760}
+        tmo = {tv_sec = 1479256824, tv_nsec = 310760000}
         ticks = <optimized out>
-#2  0x00007f626027916e in PR_WaitCondVar (cvar=0x7f6262df6010, timeout=10000) at ../../../nspr/pr/src/pthreads/ptsynch.c:398
+#2  0x00007f626027916e in PR_WaitCondVar (cvar=0x7f6262df6010, timeout=6000) at ../../../nspr/pr/src/pthreads/ptsynch.c:398
         rv = <optimized out>
         thred = 0x7f6262f87a50
 #3  0x00007f62620651e8 in eq_loop (arg=<optimized out>) at ldap/servers/slapd/eventq.c:326
@@ -2149,7 +2149,7 @@
 No locals.
 #1  0x00007f62620d00e9 in DS_Sleep (ticks=ticks@entry=1000) at ldap/servers/slapd/util.c:1035
         mSecs = <optimized out>
-        tm = {tv_sec = 0, tv_usec = 115022}
+        tm = {tv_sec = 0, tv_usec = 862699}
 #2  0x00007f6262571325 in time_thread (nothing=<optimized out>) at ldap/servers/slapd/daemon.c:216
         interval = 1000
 #3  0x00007f626027e96b in _pt_root (arg=0x7f6262f81f70) at ../../../nspr/pr/src/pthreads/ptthread.c:212