diff --git a/en-US/Connecting_to_the_Internet.xml b/en-US/Connecting_to_the_Internet.xml
index 7921362..3049ebc 100644
--- a/en-US/Connecting_to_the_Internet.xml
+++ b/en-US/Connecting_to_the_Internet.xml
@@ -4,13 +4,264 @@
 
 <chapter id="chap-User_Guide-Connecting_to_the_Internet">
 	<title>Connecting to the Internet</title>
-	<para>
-		TO DO
-	</para>
+	
+<section id="sect-User_Guide-Connecting_to_the_Internet-NetworkManager">
+		<title>NetworkManager</title>
+		<para>
+			<application>NetworkManager</application> is the application that Fedora uses to handle your connections to Internet (WWW) or your LAN. 
+		<para>
+			<application>NetworkManager</application> simplifies the process of connecting your laptop or desktop to the network. When NM is executing, you see an <guilabel>nm-applet</guilabel> icon in the System Tray of your panel (at top-rigth of your desktop),  <!--  which looks like the one below  -->.
+		</para>
+		<!--   [[Image:Docs_Drafts_DesktopUserGuide_ConfiguringInternet_nm-applet.png]]   -->
+		<para>
+			You can right click on the icon and enable wireless or wired networks. Enabling both does not affect how <application>NetworkManager</application> operates.
+		</para>
+		<para>
+			If you have a wireless network and it is supported by Fedora 13 left clicking on the icon and selecting <guilabel>Connect to other network</guilabel> and putting the details of your connection will cause <application>NetworkManager</application> to use that information to connect to the network.
+		</para>
+	</section>
+
+<!-- These is history 1--->
+	<section id="sect-User_Guide-Connecting_to_the_Internet-Configuring_PPPoE">
+		<title>Configuring PPPoE</title>
+		<para>
+			<firstterm>PPPoE</firstterm> connections are primarily used for xDSL connections. PPPoE stands for Point-to-Point Protocol over Ethernet.
+		</para>
+		<para>
+			In the main screen, click the <guilabel>New</guilabel> Button and then choose <guilabel>XDSL Configuration</guilabel> from the left hand column, clicking the <guilabel>Next</guilabel> button to proceed.
+		</para>
+		<para>
+			In the following screen, enter the name of the xDSL provider, and the username and password belonging to this account. When more than one Ethernet device is present on the system, ensure the correct device is selected from the drop down menu labeled <guilabel>Ethernet device</guilabel>. Click <guilabel>Next</guilabel> to proceed.
+		</para>
+		<para>
+			To configure this network connection to start when the system boots, click the appropriate entry in the main dialog, and then click the <guilabel>Edit</guilabel> button. Ensure that the <guilabel>Active device when computer starts</guilabel> box is ticked. To learn how to manually activate this connection refer to <xref linkend="sect-User_Guide-Connecting_to_the_Internet-NetworkManager" />.
+		</para>
+	</section>
+<!-- End History 1-->
+<!-- This also: History 2 -->
+	<section id="sect-User_Guide-Connecting_to_the_Internet-DHCP_connection">
+		<title>DHCP connection</title>
+		<note>
+			<title>DHCP is enabled by default</title>
+			<para>
+				Fedora 13 configures network interfaces to use DHCP by default. You will only need these instructions if DHCP was deactivated at some point.
+			</para>
+		</note>
+		<para>
+			DHCP connections are common when using cable modems, Local Area Networks (LANs), and most broadband Internet connections for home and small business use.
+		</para>
+		<para>
+			To enable DHCP for a particular network interface, launch <application>Network Manager</application>, select the appropriate entry for the interface and click <guilabel>Edit</guilabel>. Ensure that the <guilabel>Automatically obtain IP address settings with</guilabel> is selected and set to DHCP.
+		</para>
+	</section>
+<!-- This also: End History 2 -->
+
+
+	<section id="sect-User_Guide-Connecting_to_the_Internet-Static_IP_address">
+		<title>Static IP address</title>
+		<para>
+			To configure a network interface for a static IP address, launch <application>Network Manager</application>, and then select the network interface. Click on <guilabel>Edit</guilabel>, select the IPv4 tab and in <guilabel>Mode</guilabel> select Manual to insert your address in the <guilabel>Address</guilabel> text, using <guilabel>Add/Remove</guilabel> buttons <guilabel>Statically IP addresses</guilabel> is marked, filling in the appropriate details in the <guilabel>Manual IP Address</guilabel> section.
+		</para>
+		<para>
+			For a static IP address, it is also necessary to fill in the details in the <guilabel>DNS</guilabel> text of IPv4 tab.
+		</para>
+	</section>
+	
+	
+	
+	<section id="sect-User_Guide-Connecting_to_the_Internet-Wireless">
+		<title>Wireless</title>
+		<para>
+			Fedora includes some wireless firmware and methods to install closed-source firmware. <application>NetworkManager</application> automatically functions with the drivers that you installed in Fedora.
+		</para>
+		<para>
+			The following wireless drivers are available in the Fedora repositories: 
+			<informaltable>
+				<tgroup cols="2">
+					<thead>
+						<row>
+							<entry>
+								Firmware name
+							</entry>
+							<entry>
+								Firmware description
+							</entry>
+						</row>
+					</thead>
+					<tbody>
+						<row>
+							<entry>
+								ipw2100-firmware
+							</entry>
+							<entry>
+								Intel IPW2100
+							</entry>
+						</row>
+						<row>
+							<entry>
+								iwl3945-firmware
+							</entry>
+							<entry>
+								Intel IPW3945
+							</entry>
+						</row>
+						<row>
+							<entry>
+								iwl4965-firmware
+							</entry>
+							<entry>
+								Intel IPW4965
+							</entry>
+						</row>
+						<row>
+							<entry>
+								b43
+							</entry>
+							<entry>
+								Broadcom PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								b43legacy
+							</entry>
+							<entry>
+								Broadcom PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								adm8211
+							</entry>
+							<entry>
+								Admtek PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								p54
+							</entry>
+							<entry>
+								Prism54 USB and PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								zd1211rw
+							</entry>
+							<entry>
+								Zydas USB
+							</entry>
+						</row>
+						<row>
+							<entry>
+								rtl8180
+							</entry>
+							<entry>
+								Realtek PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								rtl8187
+							</entry>
+							<entry>
+								Realtek USB
+							</entry>
+						</row>
+						<row>
+							<entry>
+								rt2x00
+							</entry>
+							<entry>
+								Ralink USB and PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								ath5k
+							</entry>
+							<entry>
+								Atheros PCI/Cardbus
+							</entry>
+						</row>
+						<row>
+							<entry>
+								ipw2200
+							</entry>
+							<entry>
+								Intel IPW2200
+							</entry>
+						</row>
+						<row>
+							<entry>
+								orinoco/hostap
+							</entry>
+							<entry>
+								Prism2
+							</entry>
+						</row>
+					</tbody>
+				</tgroup>
+			</informaltable>
+		</para>
+		<para>
+			If you need any of these drivers, install the software using <application>PackageKit</application> by going to <menuchoice><guilabel>Applications &gt; Add/Remove Software</guilabel></menuchoice> or use the command line. For example, to install the iwl3945 firmware:
+		</para>
+		
+<screen>
+su -c &#39;yum install iwl3945&#39;
+</screen>
+		<para>
+			You can search for software by going to the search tab in <application>PackageKit</application> or by using the command line. For example, to search for the orinoco software:
+		</para>
+		
+<screen>
+su -c &#39;yum search orinoco&#39;
+</screen>
+		<note>
+			<para>
+				A current bug with some of the firmware is that the wireless light is not enabled, this does not mean the wireless card is turned off
+			</para>
+		</note>
+	</section>
+	
+	<section id="sect-User_Guide-Connecting_to_the_Internet-Remote_desktop">
+		<title>Remote desktop</title>
+		<para>
+			Fedora has remote desktop as part of the default install.
+		</para>
+		<itemizedlist>
+			<listitem>
+				<para>
+					In Gnome, select <menuchoice><guilabel>System &gt; Preferences &gt; Remote Desktop</guilabel></menuchoice>
+				</para>
+			</listitem>
+			<listitem>
+				<para>
+					In KDE, select <menuchoice><guilabel>KMenu &gt; Applications &gt; Settings &gt; Desktop Sharing</guilabel></menuchoice>
+				</para>
+			</listitem>
+		</itemizedlist>
+		<para>
+			Enabling &#39;Desktop Sharing is as simple as ticking the <guilabel>Allow other users to view your desktop</guilabel>. If you would like other people to control your desktop you can tick the appropriate setting.
+		</para>
+	</section>
+
+<para>
+Fedora 13 as seen handles networking through NM. If you prefer to use some old applications, they are there but soon they will removed. 
+</para>
 	<section id="sect-User_Guide-Connecting_to_the_Internet-GNOME">
-		<title></title>
+		<title>GNOME</title>
+		<para>
+			To launch the Network Configuration Tool in GNOME, navigate to the <menuchoice><guilabel>System &gt; Administration &gt; Network</guilabel></menuchoice> menu entry. When working as a regular user the application prompts for the root password.
+		</para>
+	</section>
+	
+	<section id="sect-User_Guide-Connecting_to_the_Internet-KDE">
+		<title>KDE</title>
 		<para>
-			
+			To launch the Network Configuration Tool in KDE, navigate to the <menuchoice><guilabel>KMenu &gt; Applications &gt; System &gt; Network </guilabel></menuchoice> menu entry. When working as a regular user the application prompts for the root password.
 		</para>
 	</section>
 
diff --git a/publican.cfg b/publican.cfg
index 870bc81..7d574c0 100644
--- a/publican.cfg
+++ b/publican.cfg
@@ -3,5 +3,5 @@
 
 debug: 1
 xml_lang: en-US
-brand: fedora
+brand: common
 