From ce6aca8324dc81e3a33c1f33f850feed23249870 Mon Sep 17 00:00:00 2001
From: Akira TAGOH <tagoh@redhat.com>
Date: Fri, 3 Aug 2012 17:02:05 +0900
Subject: [PATCH] Add fonts packages to @fonts and @legacy-fonts, which is
 missing.

---
 comps-f18.xml.in |   71 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 71 insertions(+), 0 deletions(-)

diff --git a/comps-f18.xml.in b/comps-f18.xml.in
index b2241d3..04f6240 100644
--- a/comps-f18.xml.in
+++ b/comps-f18.xml.in
@@ -1776,6 +1776,7 @@
     <default>true</default>
     <uservisible>true</uservisible>
     <packagelist>
+      <packagereq type="default">abattis-cantarell-fonts</packagereq>
       <packagereq type="default">cjkuni-uming-fonts</packagereq>
       <packagereq type="default">dejavu-sans-fonts</packagereq>
       <packagereq type="default">dejavu-sans-mono-fonts</packagereq>
@@ -1862,6 +1863,8 @@
       <packagereq type="optional">dejavu-lgc-sans-fonts</packagereq>
       <packagereq type="optional">dejavu-lgc-sans-mono-fonts</packagereq>
       <packagereq type="optional">dejavu-lgc-serif-fonts</packagereq>
+      <packagereq type="optional">denemo-emmentaler-fonts</packagereq>
+      <packagereq type="optional">denemo-feta-fonts</packagereq>
       <packagereq type="optional">denemo-music-fonts</packagereq>
       <packagereq type="optional">drehatlas-warender-bibliothek-fonts</packagereq>
       <packagereq type="optional">drehatlas-widelands-fonts</packagereq>
@@ -1882,6 +1885,7 @@
       <packagereq type="optional">gdouros-alexander-fonts</packagereq>
       <packagereq type="optional">gdouros-analecta-fonts</packagereq>
       <packagereq type="optional">gdouros-musica-fonts</packagereq>
+      <packagereq type="optional">gdouros-symbola-fonts</packagereq>
       <packagereq type="optional">gfs-ambrosia-fonts</packagereq>
       <packagereq type="optional">gfs-artemisia-fonts</packagereq>
       <packagereq type="optional">gfs-baskerville-fonts</packagereq>
@@ -1913,9 +1917,12 @@
       <packagereq type="optional">google-croscore-cousine-fonts</packagereq>
       <packagereq type="optional">google-croscore-symbolneu-fonts</packagereq>
       <packagereq type="optional">google-croscore-tinos-fonts</packagereq>
+      <packagereq type="optional">google-droid-kufi-fonts</packagereq>
       <packagereq type="optional">google-droid-sans-fonts</packagereq>
       <packagereq type="optional">google-droid-sans-mono-fonts</packagereq>
       <packagereq type="optional">google-droid-serif-fonts</packagereq>
+      <packagereq type="optional">google-lato-fonts</packagereq>
+      <packagereq type="optional">grimmer-proggy-tinysz-fonts</packagereq>
       <packagereq type="optional">gubbi-fonts</packagereq>
       <packagereq type="optional">hanazono-fonts</packagereq>
       <packagereq type="optional">hartke-aurulent-sans-fonts</packagereq>
@@ -1929,6 +1936,7 @@
       <packagereq type="optional">ipa-mincho-fonts</packagereq>
       <packagereq type="optional">ipa-pgothic-fonts</packagereq>
       <packagereq type="optional">ipa-pmincho-fonts</packagereq>
+      <packagereq type="optional">jsmath-fonts</packagereq>
       <packagereq type="optional">kacst-art-fonts</packagereq>
       <packagereq type="optional">kacst-book-fonts</packagereq>
       <packagereq type="optional">kacst-decorative-fonts</packagereq>
@@ -1944,6 +1952,9 @@
       <packagereq type="optional">kacst-screen-fonts</packagereq>
       <packagereq type="optional">kacst-title-fonts</packagereq>
       <packagereq type="optional">kacst-titlel-fonts</packagereq>
+      <packagereq type="optional">kalapi-fonts</packagereq>
+      <packagereq type="optional">kanjistrokeorders-fonts</packagereq>
+      <packagereq type="optional">kanotf-fonts</packagereq>
       <packagereq type="optional">khmeros-battambang-fonts</packagereq>
       <packagereq type="optional">khmeros-bokor-fonts</packagereq>
       <packagereq type="optional">khmeros-handwritten-fonts</packagereq>
@@ -1951,21 +1962,39 @@
       <packagereq type="optional">khmeros-muol-fonts</packagereq>
       <packagereq type="optional">khmeros-siemreap-fonts</packagereq>
       <packagereq type="optional">kurdit-unikurd-web-fonts</packagereq>
+      <packagereq type="optional">larabie-decorative-fonts</packagereq>
+      <packagereq type="optional">larabie-straight-fonts</packagereq>
+      <packagereq type="optional">larabie-uncommon-fonts</packagereq>
       <packagereq type="optional">levien-inconsolata-fonts</packagereq>
+      <packagereq type="optional">levien-museum-fonts</packagereq>
       <packagereq type="optional">liberation-narrow-fonts</packagereq>
       <packagereq type="optional">libreoffice-opensymbol-fonts</packagereq>
       <packagereq type="optional">lilypond-century-schoolbook-l-fonts</packagereq>
       <packagereq type="optional">lilypond-emmentaler-fonts</packagereq>
+      <packagereq type="optional">linux-libertine-biolinum-fonts</packagereq>
       <packagereq type="optional">linux-libertine-fonts</packagereq>
       <packagereq type="optional">lohit-malayalam-fonts</packagereq>
+      <packagereq type="optional">lohit-marathi-fonts</packagereq>
+      <packagereq type="optional">lohit-nepali-fonts</packagereq>
+      <packagereq type="optional">lohit-tamil-classical-fonts</packagereq>
       <packagereq type="optional">madan-fonts</packagereq>
+      <packagereq type="optional">manchu-fonts</packagereq>
       <packagereq type="optional">mgopen-canonica-fonts</packagereq>
       <packagereq type="optional">mgopen-cosmetica-fonts</packagereq>
       <packagereq type="optional">mgopen-modata-fonts</packagereq>
       <packagereq type="optional">mgopen-moderna-fonts</packagereq>
+      <packagereq type="optional">mona-sazanami-fonts</packagereq>
+      <packagereq type="optional">mona-vlgothic-fonts</packagereq>
       <packagereq type="optional">motoya-lcedar-fonts</packagereq>
       <packagereq type="optional">motoya-lmaru-fonts</packagereq>
       <packagereq type="optional">moyogo-molengo-fonts</packagereq>
+      <packagereq type="optional">mplus-1c-fonts</packagereq>
+      <packagereq type="optional">mplus-1m-fonts</packagereq>
+      <packagereq type="optional">mplus-1mn-fonts</packagereq>
+      <packagereq type="optional">mplus-1p-fonts</packagereq>
+      <packagereq type="optional">mplus-2c-fonts</packagereq>
+      <packagereq type="optional">mplus-2m-fonts</packagereq>
+      <packagereq type="optional">mplus-2p-fonts</packagereq>
       <packagereq type="optional">mscore-fonts</packagereq>
       <packagereq type="optional">msimonson-anonymouspro-fonts</packagereq>
       <packagereq type="optional">myanmar3-unicode-fonts</packagereq>
@@ -2034,6 +2063,7 @@
       <packagereq type="optional">sil-gentium-basic-fonts</packagereq>
       <packagereq type="optional">sil-gentium-fonts</packagereq>
       <packagereq type="optional">sil-lateef-fonts</packagereq>
+      <packagereq type="optional">sil-nuosu-fonts</packagereq>
       <packagereq type="optional">sil-scheherazade-fonts</packagereq>
       <packagereq type="optional">silkscreen-expanded-fonts</packagereq>
       <packagereq type="optional">silkscreen-fonts</packagereq>
@@ -2047,11 +2077,28 @@
       <packagereq type="optional">smc-suruma-fonts</packagereq>
       <packagereq type="optional">stix-math-fonts</packagereq>
       <packagereq type="optional">tabish-eeyek-fonts</packagereq>
+      <packagereq type="optional">tangerine-fonts</packagereq>
+      <packagereq type="optional">thai-arundina-sans-fonts</packagereq>
+      <packagereq type="optional">thai-arundina-sans-mono-fonts</packagereq>
+      <packagereq type="optional">thai-arundina-serif-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-garuda-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-kinnari-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-loma-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-norasi-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-purisa-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-sawasdee-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-tlwgmono-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-tlwgtypewriter-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-tlwgtypist-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-tlwgtypo-fonts</packagereq>
+      <packagereq type="optional">thai-scalable-umpush-fonts</packagereq>
       <packagereq type="optional">thibault-essays1743-fonts</packagereq>
       <packagereq type="optional">thibault-isabella-fonts</packagereq>
       <packagereq type="optional">thibault-rockets-fonts</packagereq>
       <packagereq type="optional">thibault-staypuft-fonts</packagereq>
       <packagereq type="optional">tibetan-machine-uni-fonts</packagereq>
+      <packagereq type="optional">tabish-eeyek-fonts</packagereq>
+      <packagereq type="optional">tangerine-fonts</packagereq>
       <packagereq type="optional">tiresias-info-fonts</packagereq>
       <packagereq type="optional">tiresias-info-z-fonts</packagereq>
       <packagereq type="optional">tiresias-key-v2-fonts</packagereq>
@@ -2061,11 +2108,16 @@
       <packagereq type="optional">tiresias-sign-fonts</packagereq>
       <packagereq type="optional">tiresias-sign-z-fonts</packagereq>
       <packagereq type="optional">tlomt-junction-fonts</packagereq>
+      <packagereq type="optional">tlomt-league-gothic-fonts</packagereq>
+      <packagereq type="optional">tlomt-orbitron-fonts</packagereq>
+      <packagereq type="optional">tlomt-sniglet-fonts</packagereq>
       <packagereq type="optional">tulrich-tuffy-fonts</packagereq>
       <packagereq type="optional">typemade-josefinsansstd-light-fonts</packagereq>
       <packagereq type="optional">ubuntu-title-fonts</packagereq>
+      <packagereq type="optional">ukij-tuz-fonts</packagereq>
       <packagereq type="optional">un-core-batang-fonts</packagereq>
       <packagereq type="optional">un-core-dinaru-fonts</packagereq>
+      <packagereq type="optional">un-core-dotum-fonts</packagereq>
       <packagereq type="optional">un-core-graphic-fonts</packagereq>
       <packagereq type="optional">un-core-gungseo-fonts</packagereq>
       <packagereq type="optional">un-core-pilgi-fonts</packagereq>
@@ -2082,8 +2134,11 @@
       <packagereq type="optional">un-extra-vada-fonts</packagereq>
       <packagereq type="optional">un-extra-yetgul-fonts</packagereq>
       <packagereq type="optional">vemana2000-fonts</packagereq>
+      <packagereq type="optional">vdrsymbol-fonts</packagereq>
       <packagereq type="optional">vlgothic-p-fonts</packagereq>
       <packagereq type="optional">vollkorn-fonts</packagereq>
+      <packagereq type="optional">wine-marlett-fonts</packagereq>
+      <packagereq type="optional">wine-symbol-fonts</packagereq>
       <packagereq type="optional">woodardworks-laconic-fonts</packagereq>
       <packagereq type="optional">woodardworks-laconic-shadow-fonts</packagereq>
       <packagereq type="optional">wqy-microhei-fonts</packagereq>
@@ -3667,7 +3722,22 @@
       <packagereq type="default">xorg-x11-fonts-ISO8859-15-100dpi</packagereq>
       <packagereq type="default">xorg-x11-fonts-misc</packagereq>
       <packagereq type="default">xorg-x11-fonts-Type1</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-anorexia-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-aqui-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-cure-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-drift-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-edges-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-fkp-fonts</packagereq>
       <packagereq type="optional">artwiz-aleczapka-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-gelly-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-glisp-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-kates-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-lime-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-mints-mild-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-mints-strong-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-nu-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-smoothansi-fonts</packagereq>
+      <packagereq type="optional">artwiz-aleczapka-snap-fonts</packagereq>
       <packagereq type="optional">baekmuk-bdf-fonts</packagereq>
       <packagereq type="optional">bitmap-console-fonts</packagereq>
       <packagereq type="optional">bitmap-fangsongti-fonts</packagereq>
@@ -3710,6 +3780,7 @@
       <packagereq type="optional">taipeifonts</packagereq>
       <packagereq type="optional">terminus-fonts</packagereq>
       <packagereq type="optional">terminus-fonts-console</packagereq>
+      <packagereq type="optional">texmacs-fedora-fonts</packagereq>
       <packagereq type="optional">ucs-miscfixed-fonts</packagereq>
       <packagereq type="optional">urw-fonts</packagereq>
       <packagereq type="optional">wqy-bitmap-fonts</packagereq>
-- 
1.7.6.5